// This file was generated by Mendix Studio Pro.
//
// WARNING: Only the following code will be retained when actions are regenerated:
// - the import list
// - the code between BEGIN USER CODE and END USER CODE
// - the code between BEGIN EXTRA CODE and END EXTRA CODE
// Other code you write will be lost the next time you deploy the project.
// Special characters, e.g., é, ö, à, etc. are supported in comments.

package shm_module.actions;

import java.math.BigDecimal;
import java.util.Iterator;
import com.mendix.core.Core;
import com.mendix.systemwideinterfaces.core.IContext;
import com.mendix.webui.CustomJavaAction;
import com.mendix.systemwideinterfaces.core.IMendixObject;

public class computeInverseData extends CustomJavaAction<java.lang.Void>
{
	private java.util.List<IMendixObject> __acc_gyro_list;
	private java.util.List<shm_module.proxies.acc_gyro> acc_gyro_list;
	private java.math.BigDecimal mass;

	public computeInverseData(IContext context, java.util.List<IMendixObject> acc_gyro_list, java.math.BigDecimal mass)
	{
		super(context);
		this.__acc_gyro_list = acc_gyro_list;
		this.mass = mass;
	}

	@java.lang.Override
	public java.lang.Void executeAction() throws Exception
	{
		this.acc_gyro_list = new java.util.ArrayList<shm_module.proxies.acc_gyro>();
		if (__acc_gyro_list != null)
			for (IMendixObject __acc_gyro_listElement : __acc_gyro_list)
				this.acc_gyro_list.add(shm_module.proxies.acc_gyro.initialize(getContext(), __acc_gyro_listElement));

		// BEGIN USER CODE
		
		
		// We dont want to do anything unless the list is of size 3 or higher.
		if(__acc_gyro_list.size()<3) {
			return null;
		}

		// torque and radius is not yet supported.
		float torque = 0;
		float radius = 1;
		
		// We ignore the first and last element of the list.
		for (int i = 1; i < __acc_gyro_list.size()-2; i++) {
			
			//Timer values for calculating the dt
			java.math.BigDecimal t0 = (BigDecimal) __acc_gyro_list.get(i-1).getMember(getContext(), "Timer");
			java.math.BigDecimal t2 = (BigDecimal) __acc_gyro_list.get(i+1).getMember(getContext(), "Timer");
			
			// IMU accelerations for the inverse method
			java.math.BigDecimal ax = (BigDecimal) __acc_gyro_list.get(i-1).getMember(getContext(), "acc_x");
			java.math.BigDecimal az = (BigDecimal) __acc_gyro_list.get(i-1).getMember(getContext(), "acc_z");

			// IMU pitch rate for the handlebar, crank, and seat acceleration calculations.
			java.math.BigDecimal dBeta0 = (BigDecimal) __acc_gyro_list.get(i-1).getMember(getContext(), "Timer");
			java.math.BigDecimal dBeta2 = (BigDecimal) __acc_gyro_list.get(i+1).getMember(getContext(), "Timer");
						
			float dt = t2.floatValue() - t0.floatValue();
			
			float ddBeta1 = (dBeta2.floatValue() - dBeta0.floatValue()) / (2*dt);
			
			// Calculating the handlebar, crank and seat accelerations
			float az_H = 0.9f * dBeta0.floatValue() + az.floatValue();
			float az_C = 0.38f * dBeta0.floatValue() + az.floatValue();
			float az_S = 0.15f * dBeta0.floatValue() + az.floatValue();

			// The list containing the final input loads
			float[] inputLoads = {	
					mass.floatValue()*ax.floatValue(),//Input load 1
					0.2f*mass.floatValue()*az_H, 			//Input load 2
					0.5f*mass.floatValue()*az_S, 			//Input load 3
					0, 										//Input load 4 is calculated later..
					0.3f*mass.floatValue()*az_C,			//Input load 5
					torque/radius							//Input load 6
			};
			
			//Input load 4 is calculated here.
			if(ax.floatValue() < 0) {
				inputLoads[3] = mass.floatValue()*ax.floatValue();
			}
			else {
				inputLoads[3] = 0.02f*mass.floatValue()*az.floatValue();
			}
			
			
			float[] outputLoads = {0, 0, 0, 0, 0, 0, 0, 0};
			
			// "Matrix multiplication" to get the output loads
			for (int k = 0; k < 8; k++) {
		        for (int j = 0; j < 6; j++) {
		          outputLoads[k] += unitLoadMatrix[k][j]*inputLoads[j]/1000000;
		        }
		    }
			
			// Creating inverse data on the server
			IMendixObject inverseData = Core.instantiate(getContext(), "SHM_Module.inverse_data"); 
			
			
			// Setting the inverseData member to the corresponding output value.
			inverseData.setValue(getContext(), "gauge1", BigDecimal.valueOf(outputLoads[0]));
			inverseData.setValue(getContext(), "gauge2", BigDecimal.valueOf(outputLoads[1]));
			inverseData.setValue(getContext(), "gauge3", BigDecimal.valueOf(outputLoads[2]));
			inverseData.setValue(getContext(), "gauge4", BigDecimal.valueOf(outputLoads[3]));
			inverseData.setValue(getContext(), "gauge5", BigDecimal.valueOf(outputLoads[4]));
			inverseData.setValue(getContext(), "gauge8", BigDecimal.valueOf(outputLoads[7]));
			
			// Setting the acc gyro associativity
			inverseData.setValue(getContext(), "SHM_Module.inverse_data_acc_gyro", __acc_gyro_list.get(i).getId()); 
			
			// Commiting the changes made to the inverse data.
			Core.commit(getContext(), inverseData);
		}
		return null;
		// END USER CODE
	}

	/**
	 * Returns a string representation of this action
	 */
	@java.lang.Override
	public java.lang.String toString()
	{
		return "computeInverseData";
	}

	// BEGIN EXTRA CODE
	private static float[][] unitLoadMatrix = {
			{262.002f, -4145.12f, -1245.9f, 9881.25f, -730.562f,  459.998f},
			  {10845.7f, 3200.66f,  -2324.07f,  -18718f, -1853.65f,  -3949.82f},
			  {-13811.4f,	-28905.200f,	-6017.640f,	84544.000f,	-8588.380f,	40.441f},
			  {15628.700f,	25590.600f,	11752.200f,	-78251.400f,	16393.400f,	-98.947f},
			  {18988.300f,	-8742.240f,	-30341.600f,	2405.160f,	-20489.200f,	845.881f},
			  {18719.700f,	-8818.380f,	-30318.700f,	2856.210f,	-20426.000f,	935.281f},
			  {15079.400f,	4344.640f,	-3474.600f,	-25773.100f,	-3227.950f,	-4762.280f},
			  {10230.400f,	2761.440f,	-1975.270f,	-16989.900f,	-4828.810f,	-226.252f}
			  };
	// END EXTRA CODE
}
