// This file was generated by Mendix Studio Pro.
//
// WARNING: Only the following code will be retained when actions are regenerated:
// - the import list
// - the code between BEGIN USER CODE and END USER CODE
// - the code between BEGIN EXTRA CODE and END EXTRA CODE
// Other code you write will be lost the next time you deploy the project.
// Special characters, e.g., é, ö, à, etc. are supported in comments.

package shm_module.actions;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Collection;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Set;
import com.mendix.core.Core;
import com.mendix.core.objectmanagement.member.MendixObjectReference;
import com.mendix.systemwideinterfaces.core.IContext;
import com.mendix.systemwideinterfaces.core.IMendixIdentifier;
import com.mendix.systemwideinterfaces.core.IMendixObject;
import com.mendix.systemwideinterfaces.core.IMendixObjectMember;
import com.mendix.systemwideinterfaces.core.meta.IMetaPrimitive;
import com.mendix.webui.CustomJavaAction;
import com.mendix.logging.ILogNode;

public class dataParseCommit extends CustomJavaAction<java.lang.Void>
{
	private java.lang.String dataString;

	public dataParseCommit(IContext context, java.lang.String dataString)
	{
		super(context);
		this.dataString = dataString;
	}

	@java.lang.Override
	public java.lang.Void executeAction() throws Exception
	{
		// BEGIN USER CODE
		if(dataString == null) {
			LOG.info("Payload is null.");
			return null;
		}
		
		String[] dataStringSplit = dataString.split(":");
		
		if(dataStringSplit.length == 1) {
			LOG.info("Payload comes with no data.");
			return null;
		}		
		
		IMendixIdentifier eventIdentifier = Core.createMendixIdentifier(dataStringSplit[0]);
		IMendixObject event = Core.retrieveId(getContext(), eventIdentifier);
		String dataTypeString = "SHM_Module.";
		
		IMendixObjectMember eventCharacteristicMember = event.getMember(getContext(), "SHM_Module.Event_Characteristic");
		IMendixIdentifier characteristicId = (IMendixIdentifier) eventCharacteristicMember.getValue(getContext());
		IMendixObject characteristic = Core.retrieveId(getContext(), characteristicId);
		IMendixObjectMember characteristicDataTypeMember = characteristic.getMember(getContext(), "SHM_Module.Characteristic_DataType");
		IMendixIdentifier dataTypeId = (IMendixIdentifier) characteristicDataTypeMember.getValue(getContext());
		IMendixObject dataType = Core.retrieveId(getContext(), dataTypeId);
		
		dataTypeString += dataType.getValue(getContext(), "Name");

		String[] data = dataStringSplit[1].split(";");
		IMendixObject objEntry = Core.instantiate(getContext(), dataTypeString);
		
		Collection<? extends IMetaPrimitive> metaPrimitives = objEntry.getMetaObject().getMetaPrimitives();
		
		if(data[0].split(",").length != metaPrimitives.size()) {
			LOG.info("Payload data is not compatible with the selected datatype." );
			LOG.info(data[0].split(",").length + " != "  + metaPrimitives.size() + ",\tDataType: " + dataTypeString );
			return null;
		}
		
		for (int i = 0; i < data.length; i++) {
			String[] entry = data[i].split(",");

			IMendixObject gageDataEntry = Core.instantiate(getContext(), dataTypeString);

			int j = 0;
			for(IMetaPrimitive metaPrimitive : metaPrimitives) {
				gageDataEntry.getMember(getContext(), metaPrimitive.getName()).parseValueFromString(getContext(), entry[j]);
				j++;
			}	
			gageDataEntry.setValue(getContext(), "SHM_Module.Data_Event", event.getId()); //dataTypeString+"_Event"
			
			Core.commit(getContext(), gageDataEntry);
		}
		return null;
		// END USER CODE
	}

	/**
	 * Returns a string representation of this action
	 */
	@java.lang.Override
	public java.lang.String toString()
	{
		return "dataParseCommit";
	}

	// BEGIN EXTRA CODE
	
	public static ILogNode LOG = Core.getLogger("RobTest");
	// END EXTRA CODE
}
